// Copyright 1993 by Jon Dart.  All Rights Reserved.

#ifndef _TYPES_H
#define _TYPES_H
#include <stdlib.h>

#ifndef _GNUC_PREREQ
#define _GNUC_PREREQ(major,minor) (__GNUC__ >= major && __GNUC_MINOR__ >= minor)
#endif

typedef unsigned char byte;
typedef int int32;
typedef unsigned int uint32;
typedef short int16;
typedef unsigned short uint16;
#ifdef _WIN32
#ifdef _MSC_VER
#include <windows.h>
  typedef unsigned __int64 hash_t;
  typedef unsigned __int64 int64;
  typedef unsigned __int64 uint64;
  #include <strstream>
//  #define MAX_PATH PATH_MAX
#else //GCC
  typedef unsigned long long hash_t;
  typedef unsigned long long int64;
  typedef unsigned long long uint64;
  #include <Windows32/Defines.h>
#if _GNUC_PREREQ(3,2)
  #include <sstream>
#else
  #include <strstream.h>
#endif
  #include <sys/time.h>
  #include <sys/types.h>
  #include <sys/times.h>
#endif
#else
typedef unsigned long long hash_t;
typedef long long int64;
typedef unsigned long long uint64;
  #include <limits.h>
  #define MAX_PATH PATH_MAX
  #include <sys/time.h>
  #include <sys/types.h>
  #include <sys/times.h>
#if _GNUC_PREREQ (3,2)
  #include <sstream>
#else
  #include <strstream.h>
#endif
  #include <unistd.h>
#endif
inline int getTime()
{
#ifdef _WIN32
#ifdef _MSC_VER
//  extern int GetTickCount();
  return GetTickCount()/10;
#else
  struct tms t;
  (void) times(&t);
  return (t.tms_utime+t.tms_stime+t.tms_cutime+t.tms_cstime)/10;
#endif
#else
  struct tms t;
  (void) times(&t);
  return t.tms_utime+t.tms_stime+t.tms_cutime+t.tms_cstime;
#endif
}
#define MAKELONGLONG(hi,lo) ((hash_t)hi<<32 | (hash_t)lo)

#ifdef _WIN32
// force _cdecl even if compiler uses fastcall
#undef CDECL
#define CDECL _cdecl
#else
#define CDECL
#endif

#endif

